 -- Create Date:    11:03:51 07/18/2012 

----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;


entity flag_rx is
    generic(
        B  : integer :=  8
    ); 
    Port (
        clk      : in  STD_LOGIC;
        reset    : in  STD_LOGIC;
        set_flag : in  STD_LOGIC;
        clr_flag : in  STD_LOGIC;
        dout_rx  : in  STD_LOGIC_VECTOR (B-1 downto 0);
        flag     : out  STD_LOGIC
    );
end flag_rx;

architecture Behavioral of flag_rx is
signal flag_reg, flag_next: std_logic; 

begin
    -- Register
    process(clk, reset)
    begin
        if rising_edge(clk) then
            if (reset = '1') then
                flag_reg <= '0'; 
            else
                flag_reg <= flag_next; 
            end if; 
        end if; 
    end process; 
    
    -- Next Logic
    process(set_flag, clr_flag, flag_reg, dout_rx)
    begin
        flag_next <= flag_reg; 
        if (set_flag = '1' and dout_rx = "00000001") then
            flag_next <= '1'; 
        elsif(clr_flag = '1')then
            flag_next <= '0'; 
        end if; 
    end process; 
    
    -- Output
    flag <= flag_reg; 

end Behavioral;

