library ieee;
library work;

use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.config.all;

entity freq_gen is
    port (
        clk    : in  std_logic;
        reset  : in  std_logic;
        count  : in  integer range 0 to MAX_COUNT;
        sw : in  std_logic;
        tick   : out std_logic
    );
    
end freq_gen;

architecture Behavioral of freq_gen is
    signal counter_reg, counter_next: integer range 0 to MAX_COUNT;
begin

-- Registers
process(clk, reset, sw)
begin
    if rising_edge(clk) then
        if reset = '1' or sw = '1' then
            counter_reg <= 0;
        else
            counter_reg <= counter_next; 
        end if; 
    end if;
end process; 
    
-- Next-state logic
counter_next <= 0 when (counter_reg = (count -1)) else (counter_reg +1);

-- output logic
tick <= '1' when (counter_reg = (count - 1)) else '0'; 
                    
end Behavioral;
