--------------------------------------------------------------------------------
-- Create date:   16:07:37 05/11/2012
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
 
entity test_adc_0820 is
end test_adc_0820;
 
architecture behavior of test_adc_0820 is 

    --inputs
    signal clk   : std_logic := '0';
    signal reset : std_logic := '0';
    signal input : std_logic_vector(7 downto 0) := (others => '0');
    signal tick  : std_logic := '0';
    signal times : std_logic := '0';

    --outputs
    signal output   : unsigned(7 downto 0);
    signal adc_done : std_logic;
    signal wr       : std_logic;
    signal mode     : std_logic := '1';

    -- clock period definitions
    constant clk_period : time := 10 ns;
 
begin
    -- instantiate the unit under test (uut)
    uut: entity work.adc_0820(behavioral)
    port map (
        clk        => clk,
        reset      => reset,
        adc_signal => input,
        tick       => tick,
        mode       => mode,
        output     => output,
        adc_done   => adc_done,
        wr         => wr
    );

    -- Clock process definitions
    clk_process :process
    begin
        clk <= '0';
        wait for clk_period/2;
        clk <= '1';
        wait for clk_period/2;
    end process;
   
    tick_process: process
    begin
        tick <= '0'; 
        wait for 20us;
        tick <= '1'; 
        wait for clk_period; 
    end process;
 

    -- Stimulus process
    stim_proc: process
    begin       
        reset <= '1'; 
        wait for 100 ns;    
        reset <= '0';
        wait for clk_period*10;

        times <= '0';
        input <= "11111000"; 
        wait for 100us;
        input <= "11000000"; 
        wait for 100us;
        input <= "11111111"; 
        wait for 100us;
        times <= '1';
        input <= "11111000"; 
        wait for 100us;
        input <= "11000000"; 
        wait for 100us;
        input <= "11111111"; 
        wait for 100us;
        
        input <= "00000000";
        wait for 10us;
        input <= "11111111";
        wait;
    end process;

end;
