library ieee;
use ieee.std_logic_1164.all;
 
entity test_freq is
end test_freq;
 
architecture behavior of test_freq is 
    --Inputs
    signal clk   : std_logic := '0';
    signal reset : std_logic  := '0';
    signal btn   : std_logic  := '0';
    signal sw    : std_logic  := '0';

    --Outputs
    signal count : integer;
    signal enable: std_logic;

    -- Clock period definitions
    constant clk_period : time := 10 ns;
begin
    -- Instantiate the Unit Under Test (UUT)
    uut: entity work.freq_sel(behavioral) port map (
        clk    => clk,
        reset  => reset,
        btn    => btn,
        sw     => sw,
        count  => count,
        enable => enable
    );

    -- Clock process definitions
    clk_process :process
    begin
        clk <= '0';
        wait for clk_period/2;
        clk <= '1';
        wait for clk_period/2;
    end process;
 
    -- Stimulus process
    stim_proc: process
    begin
        wait for 1000ns;
        reset <= '1';
        wait for 1000ns;
        reset <= '0';
        
        wait for 1000 ns;
        sw <= '1';
        wait for 1000 ns;
        sw <= '0'; -- 20Hz
        assert(count = 4883);
      
        wait for 1000ns;
        sw <= '1';
        wait for 1000 ns;
        btn <= '1';
        wait for clk_period;
        btn <= '0';
        sw <= '0'; -- 30Hz
        assert(count = 3255);
      
        wait for 1000ns;
        sw <= '1';
        wait for 1000 ns;
        btn <= '1';
        wait for clk_period;
        wait for clk_period;
        btn <= '0';
        sw <= '0'; -- 40Hz
      
        wait for 1000ns;
        sw <= '1';
        wait for 1000 ns;
        btn <= '1';
        wait for clk_period;
        wait for clk_period;
        wait for clk_period;
        btn <= '0';
        sw <= '0'; -- 50Hz
      
        wait for 1000ns;
        sw <= '1';
        wait for 1000 ns;
        btn <= '1';
        wait for clk_period;
        wait for clk_period;
        wait for clk_period;
        wait for clk_period;
        btn <= '0';
        sw <= '0'; -- 60Hz
      
        wait for 1000ns;
        sw <= '1';
        wait for 1000 ns;
        btn <= '1';
        wait for clk_period;
        wait for clk_period;
        wait for clk_period;
        wait for clk_period;
        wait for clk_period;
        btn <= '0';
        sw <= '0'; -- 70Hz
        
        wait for 1000ns;
        sw <= '1';
        wait for 1000 ns;
        btn <= '1';
        wait for clk_period;
        wait for clk_period;
        wait for clk_period;
        wait for clk_period;
        wait for clk_period;
        wait for clk_period;
        btn <= '0';
        sw <= '0'; -- 80Hz
        assert(count = 1221);
        
        wait;
    end process;
end;
